
package cn.orionsec.ops.service.impl;

import cn.orionsec.kit.lang.define.wrapper.DataGrid;
import cn.orionsec.kit.lang.utils.Objects1;
import cn.orionsec.ops.dao.MachineAlarmHistoryDAO;
import cn.orionsec.ops.entity.domain.MachineAlarmHistoryDO;
import cn.orionsec.ops.entity.request.machine.MachineAlarmHistoryRequest;
import cn.orionsec.ops.entity.vo.machine.MachineAlarmHistoryVO;
import cn.orionsec.ops.service.api.MachineAlarmHistoryService;
import cn.orionsec.ops.utils.DataQuery;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Objects;

@Service("machineAlarmHistoryService")
public class MachineAlarmHistoryServiceImpl implements MachineAlarmHistoryService {

    // TODO 最近7天的报警记录

    @Resource
    private MachineAlarmHistoryDAO machineAlarmHistoryDAO;

    @Override
    public DataGrid<MachineAlarmHistoryVO> getAlarmHistory(MachineAlarmHistoryRequest request) {
        LambdaQueryWrapper<MachineAlarmHistoryDO> wrapper = new LambdaQueryWrapper<MachineAlarmHistoryDO>()
                .eq(MachineAlarmHistoryDO::getMachineId, request.getMachineId())
                .eq(Objects.nonNull(request.getType()), MachineAlarmHistoryDO::getAlarmType, request.getType())
                .between(Objects1.isNoneNull(request.getAlarmValueStart(), request.getAlarmValueEnd()),
                        MachineAlarmHistoryDO::getAlarmValue, request.getAlarmValueStart(), request.getAlarmValueEnd())
                .between(Objects1.isNoneNull(request.getAlarmTimeStart(), request.getAlarmTimeEnd()),
                        MachineAlarmHistoryDO::getAlarmTime, request.getAlarmTimeStart(), request.getAlarmTimeEnd())
                .orderByDesc(MachineAlarmHistoryDO::getAlarmTime);
        return DataQuery.of(machineAlarmHistoryDAO)
                .page(request)
                .wrapper(wrapper)
                .dataGrid(MachineAlarmHistoryVO.class);
    }

}
